Option Explicit

Const ForReading = 1
Const ForWriting = 2
Const ForAppending = 8

Dim objWMIService, objItem, colItems
Dim strComputer, strList
Dim objFSO, objFile, objTextFile
Dim tmpFile

tmpFile = "USBcontrollers.txt"
strComputer = "."

Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")

Set colItems = objWMIService.ExecQuery ("Select * from Win32_USBController")

For Each objItem in colItems
    strList = strList & vbCr & "Configuration Manager Error Code: " & _
        objItem.ConfigManagerErrorCode
    strList = strList & vbCr & "Configuration Manager User Configuration: " & _
        objItem.ConfigManagerUserConfig
    strList = strList & vbCr & "Device ID: " & objItem.DeviceID
    strList = strList & vbCr & "Manufacturer: " & objItem.Manufacturer
    strList = strList & vbCr & "Name: " & objItem.Name
    strList = strList & vbCr & "PNP Device ID: " & objItem.PNPDeviceID
    strList = strList & vbCr & "Protocol Supported: " & objItem.ProtocolSupported
    strList = strList & vbCr
Next

Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objFile = objFSO.CreateTextFile(tmpFile)
Set objFile = nothing
Set objTextFile = objFSO.OpenTextFile(tmpFile, ForWriting, True)
    objTextFile.WriteLine(strList)
    objTextFile.Close
Set objTextFile = nothing
Set objFSO = nothing

WScript.Quit
