'=======================================================
' Classe QStringGridEx version 1.0a
' Type Objet, modified 11/2006 johnK 
' added    .SortByColumn (Column%)    SORTS the  GRID  according to Column%  by Jacques
'=======================================================

$IFNDEF __QSTRINGGRIDEX_INC      'don't reload 
    $DEFINE __QSTRINGGRIDEX_INC
    
    $DEFINE grsList 2
    $DEFINE grsEllipsis 1
    $DEFINE grsNone 0

TYPE QStringGridEx<Size> EXTENDS QStringGrid

  Public:
     RowStyle(Size) as integer
     RowList(Size) as string

  Private:

  With QStringGridEx
  '==================================
  ' Mthode style rang
  '==================================
  Sub SetStyle(Col as integer,Row as integer)
    if .RowStyle(Row)<>0 then
      if .RowStyle(Row)=2 then
        .ColumnList(Col)=.RowList(Row)
        .ColumnStyle(Col)=0
      elseif .RowStyle(Row)=1 then
        .ColumnStyle(Col)=1
      end if
    else
      .ColumnStyle(Col)=2
    end if
  End Sub
  
  '==================================
  ' Evnement slection cellule
  '==================================
  Event OnSelectCell(Col as integer,Row as integer,CanSelect as integer)
    .SetStyle Col,Row
  End Event
  
  '==================================
  ' Evnement dessin cellule
  '==================================
  Event OnDrawCell(Col as integer,Row as integer,State as integer,Rect as QRect)
    if Row=.Row then .SetStyle Col,Row
  End Event    

  Public:
  'sort the list by column
  Sub SortByColumn (iColumn As Long)
     DIM slGridColumnCopy As QStringList
     DefInt N, iPlaced, iDisplaced
'       Fill slGridColumnCopy with QStringGrid Column to Sort
        slGridColumnCopy.Clear
        For N = .FixedRows To .RowCount - 1
            slGridColumnCopy.AddItems (.Cell(iColumn, N) & " " & Str$(N))  ' Add Space Index to the item
        Next N
'       Sort slGridColumnCopy
        slGridColumnCopy.Sort
'       Swap Rows of StringGrid to sort it according to slGridColumnCopy
        For N = 0 To slGridColumnCopy.ItemCount - 2                ' -2 : last is automatically sorted
            iPlaced = Val(Mid$(slGridColumnCopy.Item(N), RInstr(slGridColumnCopy.Item(N), " ") + 1))
            iDisplaced = N + .FixedRows
            .SwapRows (iPlaced, iDisplaced)
            ' Update slGridColumnCopy for the swap ... scratch your head here
            slGridColumnCopy.Text = ReplaceSubStr$(slGridColumnCopy.Text, " " & Str$(iDisplaced) _
                    & Chr$(13) & Chr$(10), " " & str$(iPlaced) & Chr$(13) & Chr$(10))
        Next N
        slGridColumnCopy.Text = ""  'deallocate
  End Sub

  End With
End Type

$ENDIF
