'By: "cincoclavos" <cincoclavos@radar.com.ar>Sat, 20 Jul 2002 00:02:10 -0000
'a program to convert DBF into MySQL database, if you
'reformatted the code is posible convert DBF into CVS file.
' Oscar

'This program is feeware. Written by Francesco Guarnieri 2001
'(Guarnieri@Mclink.it).
'It was compiled with RQBasic (by William Yu). The author has no
'responsability for
'improper use of this program.

'Dbf2MySql is a console command to convert a .dbf file to a .sql file.
'The generated .sql file can be used to import data in to a MySql
'Database using the command: MySql.exe < SqlFile.sql

'The Memo fields are not converted.

'To generate the SqlFile type:

'Dbf2MySql <DatabaseName> <TableName> <DbfFile.dbf> <SqlFile.Sql> -<Options>

'Options:

'-c    create table
'-a    append records
'-d    drop table
'-cad  Drop Create and Append

'example:

'Dbf2Mysql Test MyTable MyTable.dbf MyFile.Sql -ca

'generate a file called MyFile.Sql that create a table Mytable into
'database Test using the command:

'Mysql < MyFile.Sql

'You can edit your MyFile.Sql for adding further commands ....


$optimize on
$apptype console
$typecheck on
$Include "RapidQ.inc"
$option icon "c:\rq\DbfMySql.ico"
Dim Db as string
Dim Tb as string
Dim Dbf as string
Dim Sql as String
Dim DbfFile as Qfilestream
Dim SqlFile as Qfilestream
Dim Str As String
Dim Opt as string
Dim C as Integer
Dim D as integer
Dim NumFs as integer
Dim LenFs as integer
Dim Rec as integer


Print "Dbf to MySql Converter ---- Written By Dr.Francesco Guarnieri"
Print "           Version 1.1 ---- Free Distribution (2001)"
Print

If Command$(1)="" or Command$(1)="/?" or Command$(1)="?" then
Print "Command Line Usage:"
Print "Dbf2MySql <MySqlDB> <MySqlTB> <InputFile.dbf> <OutputFile.Sql> -<Option>"
Print
Print "                      Options -c    [Default] Create Table"
Print "                              -ca   Create Table and Append Records"
Print "                              -a    Append Records to Table"
Print "                              -d    Drop Table"
Print "                              -dca  Drop, Create Table Append Records"
Print
Print "Command: Mysql < OutputFile.sql"

goto fine
Else
Db = Lcase$(Command$(1))
Tb = Lcase$(Command$(2))
Dbf = Lcase$(Command$(3))
Sql = Lcase$(Command$(4))
Opt = Lcase$(Command$(5))
End If

'Verifica Comando
If Field$(Dbf,".",2) <> "dbf" then
Print "Error: Invalid Parameters"
Goto Fine
Else
If Left$(Sql,1)="-" then
Opt = Sql
Sql=Field$(Dbf,".",1)+ ".Sql"
End if
If Sql="" then
Sql=Field$(Dbf,".",1)+ ".Sql"
End if
End if

If Opt="" then
Opt="-c"
End If

DbfFile.Open(Dbf,fmOpenRead)

Dim ColNam(1 to 255) as string*10
Dim ColLen(1 to 255) as integer
Dim ColTyp(1 to 255) as String*1
Dim ColDec(1 to 255) as integer


C=1
LenFs=0
Rec = 0

Str = DbfFile.ReadbinStr(32)

'Ciclo per prelevare i dati sul campo
do
Str = DbfFile.ReadStr(10)
if asc(left$(Str,1))= 13 then
exit do
end if
ColNam(c) = Field$(str,chr$(0),1)
do
Str = DbfFile.ReadBinStr(1)
loop until asc(str)>0
ColTyp(c) = Str
Str = DbfFile.ReadBinStr(4)
ColLen(c) = asc(DbfFile.ReadBinStr(1))
ColDec(c) = asc(DbfFile.ReadBinStr(1))
Str = DbfFile.ReadBinStr(14)
Print ColNam(c) ," ", ColTyp(c)," ", ColLen(c), Left$("   ",(4-Len(Str$(ColLen(c))))),ColDec(c)
LenFs=LenFs+ColLen(c)
c=c+1
loop until dbffile.eof
Print
NumFs = C-1

Print "Total Fields: ", NumFs
Print "Toltal Fields Lenght: ", LenFs
Print

SqlFile.Open(Sql,fmCreate)
SqlFile.WriteLine("Use " + Db + ";")



If instr(0,Opt,"d")>0 then
'Drop Table
SqlFile.WriteLine("DROP TABLE " + Tb + ";")

Print "Adding Command to Drop Table ..."
End if

if instr(0,Opt,"c")=0 then goto Append
' Create Table

C = 1

SqlFile.WriteLine("CREATE TABLE " + Tb + " (")

do
SqlFile.WriteStr(ColNam(c),Len(ColNam(c)))

Select Case Coltyp(c)
case  "C", "G"
SqlFile.WriteStr(" VARCHAR(" + Str$(Collen(C)) + ") DEFAULT NULL",23+len(Str$(Collen(c))))
case "D"
SqlFile.WriteStr(" DATETIME DEFAULT NULL",22)
case "L"
SqlFile.WriteStr(" CHAR(1) DEFAULT NULL ",21)
case "N" , "F"
SqlFile.WriteStr(" DECIMAL(",9)
Str= Str$(Collen(C)) + "," + Str$(Coldec(C))
SqlFile.Writestr(Str + ") DEFAULT NULL",14+len(Str))
case "M"
SqlFile.WriteStr(" TEXT",5)
end Select
If C < NumFs then
SqlFile.writeline(",")
Else
SqlFile.writeline(");")
End if
C = C+1
loop until c=NumFs + 1


Print "Adding Command to Create Table ....."
Append:

If Instr(0,Opt,"a") then
Print "Adding Commands to Append Records ......"
DbfFile.position = DbfFile.Position - 8
D = csrlin
pcopy 0,1
do
SqlFile.WriteStr("INSERT INTO " + Tb + " VALUES ('",22+len(tb))
For C = 1 to NumFs
Str = ReplacesubStr$(dbffile.readbinstr(ColLen(c)),"'"," ")
Str = ReplacesubStr$(str,","," ")
Str = ReplacesubStr$(str,chr$(0)," ")
SqlFile.WriteStr(Str,collen(c))
If c<numfs then
SqlFile.writestr("','",3)
Else
SqlFile.writestr("'",1)
End if
Next C
SqlFile.WriteLine(");")
str=dbffile.readbinstr(1)
locate 24,45
Print "Working: ",Int(DbfFile.Position/DbfFile.Size *100),"%"
Rec = Rec + 1
Loop until dbfFile.eof
pcopy 1,0
Locate D
Print "Done ......(" + Str$(Rec) + " records)"
End if

dbffile.close
SqlFile.close

Fine: