$TypeCheck on
$EscapeChars on
$include "RapidQ.inc"
$include "WindowsAPI.inc"
$include "NOTA.inc"
$resource OpenBitmap as "F:\\code\\RapidQ\\images\\00139sm.bmp"
$resource OpenBusyBitmap as "F:\\code\\RapidQ\\images\\00172_16.bmp"
$Resource blankimage as "F:\\code\\RapidQ\\images\\blank.bmp"
$Resource saveAsBitmap as "F:\\code\\RapidQ\\images\\QDisksm.bmp"
$Resource BlackDisk as "F:\\code\\RapidQ\\images\\Blackdisksm.bmp"
'Sorry, I'm holding on to these images for now...
'Paste a 16 X 16 bitmap centered onto a 25 x 25 bitmap.
'the background color should be RGB(255,0,255) to be
'transparent.

'Declare your SUBs
Declare Sub GetColors
Declare Sub OpenFileClick
declare sub InitVars
Declare Function UpDateStatus (StatText$ as string) as integer
Declare function ParseHeader as integer
Declare Sub ParseFile
Declare Sub DrawUp (ImageName$ as String, DrawNow& as integer)
Declare Sub OpenMoved
Declare Sub SaveAsMoved
Declare Sub DrawBox (ImageRef as QImage)
Declare Sub SaveAsClick
Declare sub ParseFuncs
Declare sub SelectFunc
declare sub ShowInfo (FuncNum& as integer)

'Dim your VARs
const Version$ = "(v0.9beta)"
dim NamesAndDocs as QForm
dim MakeSelection as QOpenDialog

DIM FileMenu AS QMainMenu
DIM FileMName AS QMenuItem
Dim MenuOpen as QMenuItem
Dim MenuSaveAs as QMenuItem
	FileMenu.Parent = NamesAndDocs
	FileMName.Caption = "File"
	FileMenu.AddItems FileMName
	MenuOpen.Caption = "&Open Include File"
	MenuOpen.Onclick = OpenFileClick	
	FileMName.AddItems MenuOpen
	MenuSaveAs.Caption = "&Save Include File As"
	MenuSaveAs.Onclick = SaveAsClick	
	FileMName.AddItems MenuSaveAs

'Dim OptionsName as QMenuItem
'Dim OptionsLast as QMenuItem
'	OptionsName.Caption = "Options"
'	FileMenu.AddItems OptionsName
'	OptionsLast.Caption = "Open &Last include file at startup"
'	OptionsLast.RadioItem = 1
'	OptionsLast.Checked = 0
'	OptionsName.AddItems OptionsLast

'Dim HelpName as QMenuItem
'Dim Help as QMenuItem
'Dim About as QMenuItem
'	HelpName.Caption = "Help"
'	FileMenu.AddItems HelpName
'	Help.Caption = "&Help"
'	HelpName.AddItems Help
'	About.Caption = "A&bout"
'	HelpName.AddItems About

dim HorLine1 as QImage
dim HorLine2 as QImage
dim HeaderLabel as QLabel
dim Header as QRichEdit
dim FuncsLabel as QLabel
Dim Funcs as QRichEdit
dim DocsLabel as QLabel
Dim FuncDocs as QRichEdit
dim CodeLabel as QLabel
Dim FuncCode as QRichEdit
dim status as QStatusBar
dim FuncFile as QFileStream
'QFlatButton just didn't cut it.
'Too much flicker and weird things
'happen when multiple buttons
'are used bm :C-~
Dim OpenFile as QImage
Dim SaveAsFile as QImage
dim SaveAsUp& as integer
dim OpenUp& as integer
Dim FuncFileName$ as string
dim FuncFileLen& as integer
DIM FilesOpen&  as integer 'for future use
Dim FileData$(0 to 2500) as String
dim FuncNames$(0 to 256) as string
Dim FuncStarts(0 to 256) as integer
dim FuncEnds(0 to 256) as integer
Dim CodeStarts(0 to 256) as integer
dim Header$(0 to 512) as string
Dim HeaderLen& as integer
dim FuncCount& as integer
dim SchemeR& as Integer
dim SchemeG& as Integer
dim SchemeB& as Integer
Dim CurrentFunc$ as string
'Code your main proc
Call GetColors
call initvars
NamesAndDocs.ShowModal

'Code your SUBs and FUNCs
sub ShowInfo (FuncNum& as integer)
	dim DocuWaldo& as integer
	FuncDocs.Clear
	DocsLabel.Caption = ( str$( ( CodeStarts(FuncNum&) - FuncStarts(FuncNum&) ) + 1) + " Lines of documentation." )
	for DocuWaldo& = FuncStarts(FuncNum&) to (CodeStarts(FuncNum&) - 1)
		FuncDocs.Text = ( FuncDocs.Text + FileData$(DocuWaldo&) + "\n" )
	next
	dim CodeWaldo& as integer
	FuncCode.Clear
	CodeLabel.Caption = ( str$( ( FuncEnds(FuncNum&) - CodeStarts(FuncNum&) ) + 1) + " Lines of source code." )
	for CodeWaldo& = CodeStarts(FuncNum&) to FuncEnds(FuncNum&)
		FuncCode.Text = ( FuncCode.Text + FileData$(CodeWaldo&) + "\n" )
	next
end sub

Sub SelectFunc
	If CurrentFunc$ <> FuncNames$(Funcs.WhereY) then
		CurrentFunc$ = FuncNames$(Funcs.WhereY)
		ShowInfo (Funcs.WhereY)
	end if
end sub

Sub ParseFuncs
	Funcs.Clear
	dim FuncWaldo& as Integer
	Dim TempName$ as string
	Dim NameLen& as integer
	FuncCount& = 0
	for FuncWaldo& = HeaderLen& to FuncFileLen&
		if Right$( FileData$(FuncWaldo&), 2 ) = "()" and Left$( FileData$(FuncWaldo&), 1 ) = "'" then 
			FuncStarts(FuncCount&) = FuncWaldo&
			If FuncCount& > 0 then
				FuncEnds(FuncCount& - 1) = FuncWaldo& - 1
			end if
			FuncCount& = FuncCount& + 1
		end if
		if FuncWaldo& > (FuncFileLen& - 1) then
			FuncEnds(FuncCount& - 1) = FuncFileLen&
		end if
		if FuncCount& > 255 then
			ShowMessage "Sorry, this version is limited to 256 functions.\nYou may want to seperate some functions into a new file."
			FuncWaldo& = FuncFileLen&
		end if
	next
	FuncsLabel.Caption = ( str$(FuncCount&) + " Function names found." )
	dim bryn as integer
	Dim DocWaldo& as integer
	Dim CodeWaldo& as integer
	Dim 
	dim ExtraWaldo& as integer
	Dim CodeTemp$ as string
	for bryn = 0 to (FuncCount& - 1)
		NameLen& = ( len( FileData$( FuncStarts(bryn) ) ) - 3)
		FuncNames$(bryn) = Left$( FileData$( FuncStarts(bryn) ), (NameLen& + 1) )
		FuncNames$(bryn) = Right$( FuncNames$(bryn), NameLen& )
		Funcs.Text = ( Funcs.Text + FuncNames$(bryn) + "\n" )
		for DocWaldo& = 0 to ( FuncEnds(bryn) - FuncStarts(bryn) )
			for CodeWaldo& = 0 to Len(FileData$( FuncStarts(bryn) + DocWaldo& ) )
			CodeTemp$ = Mid$( FileData$( FuncStarts(bryn) + (DocWaldo&) ), CodeWaldo&, ( Len( FuncNames$(bryn) ) + Len(" Function") ) ) 
			if UCASE$(CodeTemp$) = UCASE$( ( "Function " + FuncNames$(bryn) ) ) then
				if Mid$( FileData$( FuncStarts(bryn) + (DocWaldo&) ), 1, 1 ) <> "'" and _
				 Mid$( FileData$( FuncStarts(bryn) + (DocWaldo&) ), 2, 1 ) <> "'" and _
				 Mid$( FileData$( FuncStarts(bryn) + (DocWaldo&) ), 3, 1 ) <> "'" then
					CodeStarts(bryn) = ( FuncStarts(bryn) + (DocWaldo&) )
				end if
			end if
			next
		next
	next
	ShowInfo(0)
	CurrentFunc$ = FuncNames$(0)
end sub

Sub SaveAsClick
	SaveAsFile.BMPHandle = BlackDisk
	SaveAsFile.Center = 1
	SaveAsFile.Transparent = 1
	If FuncFileName$ = "" then
		UpDateStatus ("No action performed.")
		SaveAsFile.BMPHandle = SaveAsBitMap
		SaveASFile.Center = 1
		SaveAsFile.Transparent = 1
		end
	end if
	Dim TempFileName$ as String
	MakeSelection.Caption = ("Save " + FuncFileName$ + " as...")
	if MakeSelection.Execute then
		TempFileName$ = MakeSelection.FileName
		if TempFileName$ = FuncFileName$ then
			Messagedlg( ("Please specify a file name other than the open file.\n" + FuncFileName$ + " is already open."), mtError, mbOK, 0)
			UpDateStatus (TempFileName$ + " not saved.")
			SaveAsFile.BMPHandle = SaveAsBitMap
			SaveASFile.Center = 1
			SaveAsFile.Transparent = 1
			end
			else
				if FileExists(TempFileName$) then
					IF MessageDlg( ("Overwrite existing file?\n" + TempFileName$), mtWarning, mbYes OR mbNo, 0) = MRno THEN
						UpDateStatus (TempFileName$ + " not saved.")
						SaveAsFile.BMPHandle = SaveAsBitMap
						SaveASFile.Center = 1
						SaveAsFile.Transparent = 1
						end
					END IF
				end if
				CopyFile(FuncFileName$, TempFileName$, 0)
				FuncFileName$ = TempFileName$
				UpDateStatus (TempFileName$ + " Saved.")
		end if
		else
			UpdateStatus ("Save of " + FuncFileName$ + " aborted.")
	end if
	NamesAndDocs.Caption = "NamesAndDocs - " + FuncFileName$
	UpDateStatus (FuncFileName$ + " Saved")
	SaveAsFile.BMPHandle = SaveAsBitMap
	SaveASFile.Center = 1
	SaveAsFile.Transparent = 1
end sub

Sub DrawBox (ImageRef as QImage)
	'Light
	ImageRef.Line( 1, 1, 1, (ImageRef.Height - 2), rgb( round(SchemeR& * 1.25), round(Schemeg& * 1.25), round(Schemeb& * 1.25) ) )
	ImageRef.Line( 1, 1, (ImageRef.Width - 2), 1, rgb( round(SchemeR& * 1.25), round(Schemeg& * 1.25), round(Schemeb& * 1.25) ) )
	'Dark
	ImageRef.Line( 2, (ImageRef.Height - 2), (ImageRef.Width - 2), (ImageRef.Height - 2), rgb( round(SchemeR& * .55), round(Schemeg& * .55), round(Schemeb& * .55) ) )
	ImageRef.Line( (ImageRef.Width - 2), 2, (ImageRef.Width - 2), (ImageRef.Height - 2), rgb( round(SchemeR& * .55), round(Schemeg& * .55), round(Schemeb& * .55) ) )
	ImageRef.Transparent = 1
end Sub

sub SaveAsMoved
	DrawUp ("SaveAsFile", 1)
end sub

Sub ResetTools
	DrawUp ("OpenFile", 0)
	DrawUp ("SaveAsFile", 0)
end sub

sub OpenMoved
	DrawUp ("OpenFile", 1)
end sub

Sub DrawUp (ImageName$ as String, DrawNow& as integer)
	if  DrawNow& = 1 then
		if ( MouseX > 2 and MouseX < 23 ) and ( MouseY > 2 and MouseY < 23 ) then
			NamesAndDocs.Cursor = -21
			if ImageName$ = "OpenFile" then 
				If OpenUp& <> 1 then
					DrawBox(OpenFile)
					OpenUp& = 1
				end if
			end if
			if ImageName$ = "SaveAsFile" then 
				If SaveAsUp& <> 1 then
					DrawBox(SaveAsFile)
					SaveAsUp& = 1
				end if
			end if
			Else
			NamesAndDocs.Cursor = 0
				DrawUp ("OpenFile", 0)
				DrawUp ("SaveAsFile", 0)
		end if
	Else
			NamesAndDocs.Cursor = 0
			If OpenUp& <> 0 then
				OpenFile.BMPHandle = OpenBitMap
				OpenFile.Center = 1
				OpenUp& = 0
			end if
			If SaveAsUp& <> 0 then
				SaveAsFile.BMPHandle = SaveAsBitMap
				SaveAsFile.Center = 1
				SaveAsUp& = 0
			end if
	end if
end sub

Sub ParseHeader
	Header.Clear
	Header.PlainText = 1
	Header.WantTabs = 1
	Dim HeaderWaldo& as integer
	for HeaderWaldo& = 1 to FuncFileLen&
		if HeaderWaldo& > 512 then
			ShowMessage "Sorry, this version is limited to 512 lines of header data.\nYou may want to seperate some data into a new file."
			HeaderWaldo& = FuncFileLen&
		end if
		if Right$( FileData$(HeaderWaldo&),2 ) = "()" and Left$( FileData$(HeaderWaldo&),1 ) = "'" then 
			HeaderLen& = HeaderWaldo& - 1
			HeaderWaldo& = FuncFileLen&
		end if
	next
	if HeaderLen& = 0 then
		HeaderLen& = FuncFileLen&
	end if
	Redim Header$(HeaderLen&) as string
	dim HeaderWaldo2& as integer
	for HeaderWaldo2& = 0 to HeaderLen&
		Header$(HeaderWaldo2&) = FileData$(HeaderWaldo2&)
		Header.Text = ( Header.Text + Header$(HeaderWaldo2&) + "\n" )
	next
	HeaderLabel.Caption = ( str$(HeaderLen&) + " Lines in header." )
end sub

Sub ParseFile
	NamesAndDocs.Cursor = -11
	call ParseHeader
	Call ParseFuncs
	NamesAndDocs.Cursor = 0
end sub

Function UpdateStatus
	Status.Clear
	Status.AddPanels ("Open File: " + FuncFileName$)
	Status.AddPanels StatText$
	Status.AddPanels ( "Lines In File: " + str$(FuncFileLen&) )
	Status.Panel(0).Width = ( (NamesAndDocs.Width/2) - 60)
	Status.Panel(1).Width = ( (NamesAndDocs.Width/2) - 60)
	HorLine1.BMPHandle = BlankImage
	HorLine1.AutoSize = 1
	HorLine1.Line (0, 0, (NamesAndDocs.Width - 10), 0, RGB(round(SchemeR& * .75), round(SchemeG& * .75), round(SchemeB& * .75) ) )
	HorLine1.Line (0, 2, (NamesAndDocs.Width - 10), 2, RGB(round(SchemeR& * 1.15), round(SchemeG& * 1.15), round(SchemeB& * 1.15) ) )
	HorLine2.BMPHandle = BlankImage
	HorLine2.AutoSize = 1
	HorLine2.Line (0, 0, (NamesAndDocs.Width - 10), 0, RGB(round(SchemeR& * .75), round(SchemeG& * .75), round(SchemeB& * .75) ) )
	HorLine2.Line (0, 2, (NamesAndDocs.Width - 10), 2, RGB(round(SchemeR& * 1.15), round(SchemeG& * 1.15), round(SchemeB& * 1.15) ) )
	HeaderLabel.Top = 35
	HeaderLabel.Left = 5
	HeaderLabel.Height = 20
	Header.Height = ( (NamesAndDocs.Height / 2) - 100)
	funcs.Width = ( NamesAndDocs.Width - (NamesAndDocs.Width - 150) )' - 25 )
	Header.Width = ( (NamesAndDocs.Width - Funcs.Width) - 25)
'	Header.Width = ( (NamesAndDocs.Width / 2) + 100)
	Header.Top = 50
	Header.Left = 5
	FuncsLabel.Top = 35
	FuncsLabel.Left = (Header.Width + 10)
	FuncsLabel.Height = 20
	funcs.Left = (Header.Width + 10)
'	funcs.Width = ( (NamesAndDocs.Width - Header.Width) - 25 )
	Funcs.Height = ( (NamesAndDocs.Height / 2) - 100)
	DocsLabel.Top = (Header.Height + 50)
	DocsLabel.Left = 5
	DocsLabel.Height = 20
	FuncDocs.Height = ( ( (NamesAndDocs.Height / 2) / 2) - 20)
	FuncDocs.Width = ( (NamesAndDocs.Width) - 20)
	FuncDocs.Top = (Header.Height + 65)
	FuncDocs.Left = 5
	CodeLabel.Top = (FuncDocs.Top + FuncDocs.Height)
	CodeLabel.Left = 5
	CodeLabel.Height = 20
	FuncCode.Height = ( (NamesAndDocs.Height - (FuncDocs.Height + Header.Height) ) - 150 )
	FuncCode.Width = ( (NamesAndDocs.Width) - 20)
	FuncCode.Top = (FuncDocs.Top + FuncDocs.Height + 15)
	FuncCode.Left = 5
	NamesandDocs.Repaint
End Function

sub InitVars
	NamesAndDocs.AutoScroll = 0
	NamesAndDocs.Caption = "NamesAndDocs " + Version$ + " - The RapidQ Win32 API Function Viewer."
	NamesAndDocs.center
	NamesAndDocs.height = 480
	NamesAndDocs.width = 640
	NamesAndDocs.OnResize = UpdateStatus
'	NamesAndDocs.ShowHint = 1
'	NamesAndDocs.Hint = ""
'Darned hints won't work on QImage components...
	NamesAndDocs.OnMouseMove = ResetTools
	NamesAndDocs.DelBorderIcons = 1
	MakeSelection.Filter = "Win32 API RQ Include Files|*.inc|Basic Source Files|*.bas|Plain Text Files|*.txt|All Files|*.*"
	MakeSelection.InitialDir = CurDir$

	HorLine1.Parent = NamesAndDocs
	HorLine1.Top = 0
	HorLine1.Left = 0
	HorLine1.BMPHandle = BlankImage
	HorLine1.AutoSize = 1
	HorLine1.Line (0, 0, 630, 0, RGB(round(SchemeR& * .75), round(SchemeG& * .75), round(SchemeB& * .75) ) )
	HorLine1.Line (0, 2, 630, 2, RGB(round(SchemeR& * 1.15), round(SchemeG& * 1.15), round(SchemeB& * 1.15) ) )
	HorLine1.Transparent = 1
	HorLine2.Parent = NamesAndDocs
	HorLine2.Top = 30
	HorLine2.Left = 0
	HorLine2.BMPHandle = BlankImage
	HorLine2.AutoSize = 1
	HorLine2.Line (0, 0, 630, 0, RGB(round(SchemeR& * .75), round(SchemeG& * .75), round(SchemeB& * .75) ) )
	HorLine2.Line (0, 2, 630, 2, RGB(round(SchemeR& * 1.15), round(SchemeG& * 1.15), round(SchemeB& * 1.15) ) )
	HorLine2.Transparent = 1
	OpenFile.Parent = NamesAndDocs
	OpenFile.BMPHandle = OpenBitMap
	OpenFile.Hint = "Open Include File"
	OpenFile.ShowHint = 1
	OpenFile.left = 1
	OpenFile.Top = 3
	OpenFile.Height = 25
	OpenFile.Width = 25
	OpenFile.Center = 1
	OpenFile.Transparent = 1
	OpenFile.Onclick = OpenFileClick
	OpenFile.OnMouseMove = OpenMoved
	SaveAsFile.Parent = NamesAndDocs
	SaveAsFile.BMPHandle = SaveAsBitMap
	SaveAsFile.left = 26
	SaveAsFile.Top = 3
	SaveAsFile.Height = 25
	SaveAsFile.Width = 25
	SaveAsFile.Center = 1
	SaveAsFile.Transparent = 1
	SaveAsFile.Onclick = SaveAsClick
	SaveAsFile.OnMouseMove = SaveAsMoved
	SaveAsFile.Hint = "Save Include File As"
	SaveAsFile.ShowHint = 1
	HeaderLabel.Parent = NamesandDocs
	HeaderLabel.Caption = "Header Info"
	Header.Parent = NamesAndDocs
	Header.ShowHint = 1
	Header.Hint = (FuncFileName$ + " File Header")
	Header.Taborder = 0
	Header.ReadOnly = 1
	Header.WordWrap = 0
	Header.Scrollbars = 3
	Header.OnMouseMove = ResetTools
	FuncsLabel.Parent = NamesandDocs
	FuncsLabel.Caption = "Function Names"
	Funcs.Parent = NamesAndDocs
	Funcs.Top = 50
	Funcs.ReadOnly = 1
	Funcs.WordWrap = 0
	Funcs.Scrollbars = 3
	Funcs.OnMouseMove = ResetTools
	Funcs.OnMouseDown = SelectFunc
	Funcs.OnKeyUp = SelectFunc
	DocsLabel.Parent = NamesandDocs
	DocsLabel.Caption = "Function Documentation"
	FuncDocs.Parent = NamesAndDocs
	FuncDocs.ReadOnly = 1
	FuncDocs.WordWrap = 0
	FuncDocs.Scrollbars = 3
	FuncDocs.OnMouseMove = ResetTools
	CodeLabel.Parent = NamesandDocs
	CodeLabel.Caption = "Function Source Code"
	FuncCode.Parent = NamesAndDocs
	FuncCode.ReadOnly = 1
	FuncCode.WordWrap = 0
	FuncCode.Scrollbars = 3
	FuncCode.OnMouseMove = ResetTools
	Status.Parent = NamesAndDocs
	Status.Height = 20

'ShowModal!!!!
	UpdateStatus "By Bryn Mosher"
end sub

sub OpenFileClick
	OpenFile.BMPHandle = OpenBusyBitMap
	OpenFile.Center = 1
	OpenFile.Transparent = 1
	MakeSelection.Caption = "Please select a RapidQ WIN32 API Include file..."
	if MakeSelection.Execute then
		FuncFileName$ = MakeSelection.FileName
		if FileExists(FuncFileName$) then
			NamesAndDocs.Cursor = -11
			FuncFile.Open(FuncFileName$, 0)
			redim FuncNames$(0 to 256) as string
			reDim FuncStarts(0 to 256) as integer
			redim FuncEnds(0 to 256) as integer
			reDim CodeStarts(0 to 256) as integer
			redim Header$(0 to 512) as string
			ReDim FileData$(0 to FuncFile.LineCount) as string 
			for FuncFileLen& = 0 to FuncFile.Linecount
				FileData$(FuncFileLen&) = (FuncFile.ReadLine)
				if FuncFileLen& > 2499 then
					ShowMessage "Sorry, this version is limited to 2500 lines of data.\nYou may want to seperate some data into a new file."
					FuncFileLen& = FuncFile.Linecount
				end if
			next
			FuncFileLen& = FuncFile.Linecount
			FuncFile.Close
			FilesOpen& = (FilesOpen& + 1)
			call ParseFile
			NamesAndDocs.Caption = "NamesAndDocs - " + FuncFileName$
			UpDateStatus "File freshly opened."
			else
				dim OpenError& as integer
				OpenError& = GetLastError
				if OpenError& <> 2 then
					FuncFileName$ = ( "WINDOWS ERROR CODE: " + str$(OpenError&) )
					Else
						FuncFileName$ = ( "ERROR CODE: " + str$(OpenError&) + " The file does not exist." )
				end if
				UpDateStatus "File open error!"
		end if
		else
		UpdateStatus ("File open aborted.")
	end if
	NamesAndDocs.Cursor = 0
	OpenFile.BMPHandle = OpenBitMap
	OpenFile.Center = 1
	OpenFile.Transparent = 1
end sub

SUB GetColors
	Dim ColorScheme as QRegistry
	Dim SchemeText$ as string
	ColorScheme.OpenKey("\\Control Panel\\Colors", 0)
	if ColorScheme.ValueExists("ButtonFace") then
		SchemeText$ =  ColorScheme.ReadString("ButtonFace")
		else
			SchemeText$ = "150 150 150"
	end if
	ColorScheme.closeKey
	dim SchemeWaldo& as integer
	for SchemeWaldo& = 0 to Len(SchemeText$)
		if Mid$( SchemeText$, ( Len(SchemeText$) - SchemeWaldo& ), 1 ) = " " then
			SchemeB& = Val( Right$(SchemeText$, SchemeWaldo&) )
			SchemeText$ = Left$( SchemeText$, ( ( Len(SchemeText$) - SchemeWaldo& ) - 1 ) )
			SchemeWaldo& = Len(SchemeText$)
		end if
	next
	SchemeWaldo& = 0
	for SchemeWaldo& = 0 to Len(SchemeText$)
		if Mid$( SchemeText$, ( Len(SchemeText$) - SchemeWaldo& ), 1 ) = " " then
			SchemeG& = Val( Right$(SchemeText$, SchemeWaldo&) )
			SchemeText$ = Left$( SchemeText$, ( ( Len(SchemeText$) - SchemeWaldo& ) - 1 ) )
			SchemeWaldo& = Len(SchemeText$)
		end if
	next
	SchemeR& = Val(SchemeText$)
end SUB



