$INCLUDE <rapidq2.inc>
$INCLUDE <XpGroupBox.inc>
$OPTION ICON "Raptor.ico"

$RESOURCE SRCBMP AS "Seashell32.bmp"   ' 32 bit source bitmap with a lot of alpha transparency

DIM BMSrc AS QBITMAP
BMSrc.BMPHandle = SRCBMP

' Background
DIM BkGrnd AS QBITMAP
BkGrnd.Width  = BMSrc.Width
BkGrnd.Height = BMSrc.Height
BkGrnd.FillRect(0, 0, BMSrc.Width, BMSrc.Height, clBtnFace)

' For results of alphablends
DIM BMRes1 AS QBITMAP
DIM BMRes2 AS QBITMAPEX
DIM BMRes3 AS QBITMAPEX
DIM BMRes4 AS QBITMAPEX
DIM BMRes5 AS QBITMAPEX

' AlphaBlend no PreMultiply
BMRes1.BMP = BkGrnd.BMP
AlphaBlend(BMRes1.Handle, 0, 0, BMRes1.Width, BMRes1.Height, _
        BMSrc.Handle, 0, 0, BMSrc.Width, BMSrc.Height, &H01FF0000)

' 100% AlphaBlend with PreMultiply
BMRes2.AlphaBlend(BkGrnd, BMSrc, -1)

' 10% AlphaBlend with PreMultiply
BMRes3.AlphaBlend(BkGrnd, BMSrc, -.1)

' 25% AlphaBlend with PreMultiply
BMRes4.AlphaBlend(BkGrnd, BMSrc, -.25)

' 50% AlphaBlend with PreMultiply
BMRes5.AlphaBlend(BkGrnd, BMSrc, -.5)

CREATE Form AS QFORM
  Top    = 0
  Left   = 214
  Width  = 800
  Height = 570
  Caption = "32 bit AlphaBlend Test"
  CREATE GroupBox1 AS XpGroupBox
    Top    = 10
    Left   = 10
    Width  = 250
    Height = 250
    Caption = "32 bit Original Raw"
    CREATE Image1 AS QIMAGE
      Top  = 20
      Left = 10    
      AutoSize = True
      BMP = BMSrc.BMP
    END CREATE
  END CREATE
  CREATE GroupBox2 AS XpGroupBox
      Top    = 10
    Left   = 270
    Width  = 250
    Height = 250
    Caption = "AlphaBlend no PreMultiply"
    CREATE Image2 AS QIMAGE
      Top   = 20
      Left  = 10
      AutoSize = True
      BMP = BMRes1.BMP
    END CREATE
  END CREATE
  CREATE GroupBox3 AS XpGroupBox
    Top    = 10
    Left   = 530
    Width  = 250
    Height = 250
    Caption = "100% AlphaBlend with PreMultiply"
    CREATE Image3 AS QIMAGE
      Top  = 20
      Left = 10 
      AutoSize = True
      BMP = BMRes2.BMP
    END CREATE
  END CREATE
  CREATE GroupBox4 AS XpGroupBox
    Top    = 270
    Left   = 10
    Width  = 250
    Height = 250
    Caption = "10% AlphaBlend with PreMultiply"
    CREATE Image4 AS QIMAGE
      Top  = 20
      Left = 10    
      AutoSize = True
      BMP = BMRes3.BMP
    END CREATE
  END CREATE
  CREATE GroupBox5 AS XpGroupBox
    Top    = 270
    Left   = 270
    Width  = 250
    Height = 250
    Caption = "25% AlphaBlend with PreMultiply"
    CREATE Image5 AS QIMAGE
      Top   = 20
      Left  = 10
      AutoSize = True
      BMP = BMRes4.BMP
    END CREATE
  END CREATE
  CREATE GroupBox6 AS XpGroupBox
    Top    = 270
    Left   = 530
    Width  = 250
    Height = 250
    Caption = "50% AlphaBlend with PreMultiply"
    CREATE Image6 AS QIMAGE
      Top  = 20
      Left = 10 
      AutoSize = True
      BMP = BMRes5.BMP
    END CREATE
  END CREATE
  ShowModal
END CREATE
